<template>
  <div class="section">
    <div class="container">
      <div v-if="hasError" class="notification is-danger">Invalid username or password</div>
      <form @submit.prevent="onSubmit">
        <div class="field">
          <label class="label">Username</label>
          <div class="control">
            <input v-model="username" class="input" type="text" placeholder="Username" autofocus>
          </div>
        </div>

        <div class="field">
          <label class="label">Password</label>
          <div class="control">
            <input v-model="password" class="input" :class="{ 'is-danger': hasError }" type="password" placeholder="Password">
          </div>
        </div>

        <div class="field is-grouped">
          <div class="control">
            <button class="button is-primary" type="submit">Login</button>
          </div>
          <div class="control">
            <button class="button is-primary" type="reset" @click="onReset">Reset</button>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import { Action } from 'vuex-class';
import { restfulClient } from '../client';

@Component({})
export default class AuthPage extends Vue {
  username: string = '';
  password: string = '';
  hasError: boolean = false;

  @Action('setAuth') setAuth!: (auth: any) => void;

  onSubmit() {
    restfulClient.post('auth', null, {
      auth: {
        username: this.username,
        password: this.password,
      },
      validateStatus: (status) => status < 500 && status >= 200,
    })
      .then(({ status }) => {
        if (status === 200) {
          this.setAuth({
            username: this.username,
            password: this.password,
          });
          this.$router.push({ path: '/' });
        } else {
          this.password = '';
          this.hasError = true;
        }
      });
  }

  onReset() {
    this.username = '';
    this.password = '';
  }
}
</script>
